/* This is a private (internal) header file for adc.c, of the AT-MIO-16X driver */

#define ADC_MAXCHANS 20

typedef struct ADC_t {
	int		dmaintclr;			/* Address of Interrupt clear 	*/

	int		nchans;				/* Number of channels in CAM    */
	short	cam[ADC_MAXCHANS];	/* channel access memory*/
	int		started;			/* Has acquisition started?     */
	int		samplerate;			/* samplerate for each chan     */
	int		clockspeed;			/* clockspeed for samp.interval */
	int		usedma;				/* Flag: use DMA or IRQ ? */
	int		watchdog;
	int		sampcnt;
	int		cnt;
	int		total;

	int		status;				/* Status of card		*/
	int		overrun;			/* Status of card		*/
	int		overflow;			/* Status of card		*/
	int		open;				/* Is device open?		*/
	int		triggermode;		/* Select ADC trigger mode	*/

	void	*frontbuf;			/* ADC data buffer		*/
	void	*backbuf;			/* ADC data buffer		*/
	int		bufsize;			/* Size of buffer		*/
	int		count;				/* Number of values to read	*/
	int		indx;				/* Data buffer index		*/
	int		incr;				/* Data buffer index		*/

	struct semaphore sem;		/* Semaphore to lock port access*/
	struct wait_queue *wait;
} ADC_t;

extern void adc_interrupt( ADC_t *adc, int status );
extern ADC_t *get_adc( int minor );
extern void free_adc( ADC_t *adc );
extern int trigger_adc( ADC_t *adc );

