/* This is a private (internal) header file for dac.c, of the AT-MIO-16X driver */

typedef struct DAC_t
{
	int		open;				/* Is device open?		*/

	int     chans;             /* use 1 or 2 output channels.  Default = 1 */
	int		watchdog;
	int		samplerate;			/* samplerate for each chan     */
	int		clockspeed;			/* clockspeed for samp.interval */
	int		status;				/* Status of card		*/

	unsigned long long total;	/* 64bit Total # of samples transferred */
	unsigned long long writetime;/* 64bit Time (in samples from start) of 1st sample of previous write */

	int		timemarkflag;		/* Flag.  When 1, the IRQ routine fills in writetime[] on next write */

	void	*zerobuf;			/* DAC data buffer		*/
	void	*frontbuf;			/* DAC data buffer		*/
	void	*backbuf;			/* DAC data buffer		*/
	int		bufsize;			/* Size of buffer		*/
	int		bufcount;			/* # samples in backbuf */
	int		count;				/* # of samples in frontbuf being transferred */

	struct semaphore sem;		/* Semaphore to lock port access*/
	struct wait_queue *wait;
} DAC_t;

extern void dac_interrupt( DAC_t *dac, int status );
extern DAC_t *get_dac( int minor );
extern void free_dac( DAC_t *dac );
extern int trigger_dac( DAC_t *dac );

