/* This is a private (internal) header file for dio.c, of the AT-MIO-16X driver */

#define DIO_MAXCHANS 20

typedef struct DIO_t {

	int		iomode;				/* PortA, PortB input/output */
	int		status;				/* Status of card		*/
	int		open;				/* Is device open?		*/

	struct semaphore sem;		/* Semaphore to lock port access*/
	struct wait_queue *wait;
} DIO_t;

extern DIO_t *get_dio( int minor );
extern void free_dio( DIO_t *dio );

