#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "atMIO16x.h"

#define HANDERRNO(errno) {if (errno) perror(NULL);}
#define DATABUFSIZE 1000000

main(int ac, char *av[])
{
	FILE *fp;
	char buf[80];
	int i, status, fd, samplerate, clockspeed, sampcnt, cnt, tmp, total;
	ADC_chan_t tmpchan;
	short databuf[DATABUFSIZE];
	unsigned long long samplecnt;
	int chans;

	if (ac == 1)
	{
		fprintf(stderr, "Usage: test_dac <init> <start> <status> <write file.pcm>\n");
		fprintf(stderr, "          <setsr n> <getsr> <setclock n> <getclock>\n");
		fprintf(stderr, "          <trigger> <strigger> <gettime> <gettotal>\n");
		fprintf(stderr, "          <one> <two> <both> <setmark> <getchans> <pause>\n");
		return -1;
	}

	fd = open("/dev/atmio16x/dac", O_RDWR);
	if (errno != 0) perror(NULL);

	for (i=1; i < ac; i++)
	{
		if (!strcmp(av[i], "init"))
		{
			ioctl(fd, DAC_INIT, NULL);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "getclock"))
		{
			ioctl(fd, DAC_GETCLOCK, &clockspeed);
			HANDERRNO(errno);
			printf("%d\n", clockspeed);
		}
		else if (!strcmp(av[i], "setclock"))
		{
			sscanf(av[++i], "%d", &clockspeed);
			ioctl(fd, DAC_SETCLOCK, &clockspeed);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "getsr"))
		{
			ioctl(fd, DAC_GETSR, &samplerate);
			HANDERRNO(errno);
			printf("%d\n", samplerate);
		}
		else if (!strcmp(av[i], "setsr"))
		{
			sscanf(av[++i], "%d", &samplerate);
			ioctl(fd, DAC_SETSR, &samplerate);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "one"))
		{
			chans = 1;
			ioctl(fd, DAC_SETCHANS, &chans);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "two"))
		{
			chans = 2;
			ioctl(fd, DAC_SETCHANS, &chans);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "both"))
		{
			chans = 1 | 2;
			ioctl(fd, DAC_SETCHANS, &chans);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "getchans"))
		{
			ioctl(fd, DAC_GETCHANS, &chans);
			HANDERRNO(errno);
			printf("chans = %d\n", chans);
		}
		else if (!strcmp(av[i], "start"))
		{
			ioctl(fd, DAC_START, NULL);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "trigger"))
		{
			ioctl(fd, DAC_TRIGGER, NULL);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "strigger"))
		{
			ioctl(fd, DAC_STRIGGER, NULL);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "status"))
		{
			ioctl(fd, DAC_STATUS, &status);
			HANDERRNO(errno);
			printf("status = 0x%x\n", status);
		}
		else if (!strcmp(av[i], "setmark"))
		{
			ioctl(fd, DAC_SETTIMEMARK, NULL);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "gettime"))
		{
			ioctl(fd, DAC_GETWRITETIME, &samplecnt);
			HANDERRNO(errno);
			printf("time = %qd\n", samplecnt);
		}
		else if (!strcmp(av[i], "gettotal"))
		{
			ioctl(fd, DAC_GETTOTAL, &samplecnt);
			HANDERRNO(errno);
			printf("total = %qd\n", samplecnt);
		}
		else if (!strcmp(av[i], "write"))
		{
			if (fp = fopen(av[++i], "r"))
			{
				total = fread(databuf, 1, DATABUFSIZE, fp);
				fclose(fp);
				printf("file size = %d\n", total);
				write(fd, databuf, total);
				HANDERRNO(errno);
			}
		}
		else if (!strcmp(av[i], "pause"))
		{
			printf("waiting...");
			gets(buf);
			printf("done\n");
		}
	}
	close(fd);
}

