#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "atMIO16x.h"

#define HANDERRNO(errno) {if (errno) perror(NULL);}
#define DATABUFSIZE 1000000

int main(int ac, char *av[])
{
	FILE *fp;
	char buf[80];
	int i, status, fd;
	int mode = 0, bits = 0;

	if (ac == 1)
	{
		fprintf(stderr, "Usage: %s <ain> <aout> <bin> <bout> <set n> <get> <pause>\n", av[0]);
		return -1;
	}

	fd = open("/dev/atmio16x/dio", O_RDWR);
	if (errno != 0) perror(NULL);

	for (i=1; i < ac; i++)
	{
		if (!strcmp(av[i], "ain"))
		{
			mode |= DIOMODE_PORTA_INPUT;
			mode &= (255 - DIOMODE_PORTA_OUTPUT);
			ioctl(fd, DIO_SETMODE, &mode);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "aout"))
		{
			mode |= DIOMODE_PORTA_OUTPUT;
			mode &= (255 - DIOMODE_PORTA_INPUT);
			ioctl(fd, DIO_SETMODE, &mode);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "bin"))
		{
			mode |= DIOMODE_PORTB_INPUT;
			mode &= (255 - DIOMODE_PORTB_OUTPUT);
			ioctl(fd, DIO_SETMODE, &mode);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "bout"))
		{
			mode |= DIOMODE_PORTB_OUTPUT;
			mode &= (255 - DIOMODE_PORTB_INPUT);
			ioctl(fd, DIO_SETMODE, &mode);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "get"))
		{
			ioctl(fd, DIO_GETBITS, &bits);
			HANDERRNO(errno);
			printf("bits = %02x\n", bits & 0xff);
		}
		else if (!strcmp(av[i], "set"))
		{
			sscanf(av[++i], "%x", &bits);
			ioctl(fd, DIO_SETBITS, &bits);
			HANDERRNO(errno);
		}
		else if (!strcmp(av[i], "pause"))
		{
			printf("waiting...");
			gets(buf);
			printf("done\n");
		}
	}
	close(fd);
	return 0;
}

